package com.ynet.life.util;

import com.ynet.life.base.Trace;
import com.ynet.life.exception.TranFailException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Random;

public class RandomGUID {

   public String valueBeforeMD5 = "";
   public String valueAfterMD5 = "";
   private static Random myRand;
   private static SecureRandom mySecureRand;
   private static String s_id;


   static {
      long e = (mySecureRand = new SecureRandom()).nextLong();
      myRand = new Random(e);

      try {
         s_id = InetAddress.getLocalHost().toString();
      } catch (UnknownHostException var2) {
         Trace.logError("LifeCore", var2.getMessage(), var2);
      }
   }

   public RandomGUID() {
      this.getRandomGUID(false);
   }

   public RandomGUID(boolean secure) {
      this.getRandomGUID(secure);
   }

   private void getRandomGUID(boolean array) {
      MessageDigest sb = null;
      StringBuffer j = new StringBuffer();

      try {
         if((sb = MessageDigest.getInstance("MD5")) == null) {
            Trace.logError("LifeCore", "MD5计算失败", new TranFailException("EBLN0035", "MD5计算失败"));
            return;
         }
      } catch (NoSuchAlgorithmException var9) {
         Trace.logError("LifeCore", var9.getMessage(), var9);
      }

      try {
         long e = System.currentTimeMillis();
         long rand;
         if(array) {
            rand = mySecureRand.nextLong();
         } else {
            rand = myRand.nextLong();
         }

         j.append(s_id);
         j.append(":");
         j.append(Long.toString(e));
         j.append(":");
         j.append(Long.toString(rand));
         this.valueBeforeMD5 = j.toString();
         sb.update(this.valueBeforeMD5.getBytes());
         byte[] var10 = sb.digest();
         StringBuffer var11 = new StringBuffer();

         for(int var12 = 0; var12 < var10.length; ++var12) {
            int var13;
            if((var13 = var10[var12] & 255) < 16) {
               var11.append('0');
            }

            var11.append(Integer.toHexString(var13));
         }

         this.valueAfterMD5 = var11.toString();
      } catch (Exception var8) {
         Trace.logError("LifeCore", var8.getMessage(), var8);
      }
   }

   public static String generateDigest(String sb) {
      MessageDigest j = null;

      try {
         j = MessageDigest.getInstance("MD5");
      } catch (NoSuchAlgorithmException var4) {
         Trace.logError("LifeCore", var4.getMessage(), var4);
      }

      j.update(sb.getBytes());
      byte[] array = j.digest();
      StringBuffer var5 = new StringBuffer();

      for(int var6 = 0; var6 < array.length; ++var6) {
         int b;
         if((b = array[var6] & 255) < 16) {
            var5.append('0');
         }

         var5.append(Integer.toHexString(b));
      }

      return var5.toString();
   }

   public static String getRandom(int length) {
      if(length > 32) {
         length = 32;
      }

      return (new RandomGUID()).valueAfterMD5.toUpperCase().substring(0, length);
   }

   public static final String toFixedIntStr(String val) {
      int h = 0;
      int off = 0;
      if(val == null) {
         return "91234";
      } else {
         char[] var5;
         int len = (var5 = val.toCharArray()).length;

         for(int i = 0; i < len; ++i) {
            h = h * 31 + var5[off++];
         }

         return Math.abs(h) + "91234";
      }
   }

   public String toString() {
      String raw = this.valueAfterMD5.toUpperCase();
      System.out.println("Raw:" + raw.length());
      StringBuffer sb;
      (sb = new StringBuffer()).append(raw.substring(0, 12));
      sb.append("-");
      sb.append(raw.substring(8, 12));
      sb.append("-");
      sb.append(raw.substring(12, 16));
      sb.append("-");
      sb.append(raw.substring(16, 20));
      sb.append("-");
      sb.append(raw.substring(20));
      return sb.toString();
   }

   public static void main(String[] userid) {
      String userid1 = "10531112198201011234";
      System.out.println(toFixedIntStr(userid1));
   }
}
